import java.sql.*;
import java.io.*;
import java.math.*;
import java.lang.*;

public class LivreTypePourUDT implements SQLData {

    // nomUDT contient le nom du UDT qui correspond  la classe
    private String nomUDT = "GODIN.LIVRETYPE";
    protected String ISBN;
    protected String titre;
    protected Typedonnesanne anneParution;
    protected java.sql.Ref diteur; 

  public LivreTypePourUDT(){}

  // Lecteurs et modifieurs
  public String getIsbn(){ return ISBN; }
  public void setIsbn(String isbn){ this.ISBN = isbn; }

  public String getTitre(){ return titre; }
  public void setTitre(String titre){ this.titre = titre; }

  public Typedonnesanne getAnneparution(){ return anneParution; }
  public void setAnneparution(Typedonnesanne anneparution)
  { this.anneParution = anneparution; }

  public java.sql.Ref getditeur(){ return diteur; }
  public void setditeur(java.sql.Ref diteur){ this.diteur = diteur; }

  // Mthode de service
  public oracle.sql.NUMBER getLengthTitre(){ return new oracle.sql.NUMBER(titre.length());}

//  public int getLengthTitre(){ return titre.length();}
  public String getTitreEnMinuscules(){return titre.toLowerCase();}

  // Mthodes de l'interface SQLdata  implmenter

  // Retourne le UDT SQL qui correspond  la classe Java
  public String getSQLTypeName() throws SQLException { return nomUDT;} 

  public void readSQL(SQLInput stream, String type)
  throws SQLException{
      setIsbn(stream.readString());
      setTitre(stream.readString());
      setAnneparution((Typedonnesanne)stream.readObject());
      setditeur(stream.readRef());
  }
  public void writeSQL(SQLOutput stream)
  throws SQLException{
      stream.writeString(getIsbn());
      stream.writeString(getTitre());
      stream.writeObject(getAnneparution());
      stream.writeRef(getditeur());
  }
}
